class C_STRUCT_TEST
   
creation 
   test1, test2
   
   
feature
   test1 is
	  local 
		 a_c_struct: C_STRUCT;
	  do
		 a_c_struct := create_someone("someone", 10);
		 print_struct(a_c_struct);
		 a_c_struct.set_name("someone else");
		 io.put_string(a_c_struct.name);
		 io.put_new_line;
		 a_c_struct := Void; -- forget the c_struct calls dispose and frees the allocated memory checked with dmalloc 
	  end;
   
   test2 is
	  local
		 a_c_struct: C_STRUCT;
		 array_with_c_structs: ARRAY[C_STRUCT];
	  do
		 !!array_with_c_structs.make(1,2);
		 a_c_struct := create_someone("someone", 10);
		 -- putting into the Array from Eiffel
		 array_with_c_structs.put(a_c_struct, 1);
		 print_array(array_with_c_structs);
		 a_c_struct := create_someone("someone else", 20);
		 -- putting it into an Eiffel-Array from C 
		 c_put_struct(array_with_c_structs, a_c_struct, 2);
		 print_array(array_with_c_structs);
		 array_with_c_structs := Void;
	  end;
   
feature{NONE}
   
   print_struct(a_c_struct: C_STRUCT) is
	  require
		 struct_not_void: a_c_struct /= Void;
	  do
		 -- mixed language programming 
		 -- Eiffel
		 io.put_string(a_c_struct.name);
		 io.put_new_line;
		 -- C 
		 a_c_struct.print_age;
	  end;
   
   print_array (c_struct_array: ARRAY[C_STRUCT]) is
	  local
		 i: INTEGER;
	  do
		 from i:= c_struct_array.lower;
		 until i > c_struct_array.upper
		 loop
			if c_struct_array.item(i) /= Void then
			   print_struct(c_struct_array.item(i));
			end;
			i := i + 1;
		 end; -- loop
		 io.put_new_line;
	  end; -- print_array
   
   create_someone(a_name: STRING; age: INTEGER): C_STRUCT is
	  do
		 !!Result.make(a_name, age);
	  end;
   

   c_put_struct( acs_array: ARRAY[C_STRUCT]; 
				 a_c_struct: C_STRUCT; 
				 index: INTEGER) is
	  external "C"
	  end;
		 
   
end
